// Lab17_IIR.pde
// MUSC208 John Ellinger Winter2014

import oscP5.*;
import netP5.*;
import controlP5.*;

ControlP5 cp5;
// the controlP5 controls
Slider sliderGain;
Slider sliderA0;
Slider sliderB1;
Toggle lohiToggle;
Toggle bypassToggle;


// OscP5 is name of class, oscP5 is a variable instance of that class
OscP5 oscP5; 
// ChucK network address
// on the same computer it will be "127.0.0.1"
// or "localhost"
NetAddress ChuckAddress; 

// GUI control layout
void addGUIControls()
{
  // create the font used for for control labels
  // use true/false for anti-aliased/not anti-aliased
  PFont pfont = createFont("Arial", 16, true); 
  ControlFont font = new ControlFont (pfont );
  cp5.setControlFont( font );

  // slider dimensions
  int sliderHt = 20;    // slider height
  int sliderWid = 480;  // slider width
  // control default colors
  int bkgColor = color(128);            // light gray
  int foreColor = color(255, 255, 162);   // light yellow
  int activeColor = color(255, 255, 162); // light yellow

  // create slider Gain
  sliderGain = cp5.addSlider( "Gain" ) // Gain is the control label
    .setPosition(20, 16)              // 20 pixels in from left, 16 down from top
      .setSize( sliderWid, sliderHt )   // 480 pixels wide by 20 pixels tall
        .setRange( 0, 1 )                 // slider minimum value is 0, max is 1.0
          .setValue( 0.5 )                  // initial setting at 0.5
              .setColorCaptionLabel(0)          // caption color is black
              .setColorValueLabel(0)            // label color is black
                .setDecimalPrecision(2)           // display 2 decimal places
                  .setColorBackground( bkgColor )   // dark gray
                    .setColorForeground( foreColor )  // light yellow
                      .setColorActive( activeColor )    // light yellos
                        ;
  // change control label font and size
  cp5.getController("Gain").getCaptionLabel().toUpperCase(false);

  // create slider A0
  sliderA0 = cp5.addSlider( "a0" ) // a0 is the control label
    .setPosition(20, 48)             // XX means you figure it out
      .setSize( sliderWid, sliderHt )   // 480 pixels wide by 20 pixels tall
        .setRange( 0, 1 )                 // slider minimum value is 0, max is 1.0
          .setValue( 0.5 )                  // initial setting at 0.5
              .setColorCaptionLabel(0)          // caption color is black
              .setColorValueLabel(0)            // label color is black
                .setDecimalPrecision(2)           // display 2 decimal places
                  .setColorBackground( bkgColor )   // dark gray
                    .setColorForeground( foreColor )  // light yellow
                      .setColorActive( activeColor )    // light yellos
                        ;
  // change control label font and size
   cp5.getController("a0").getCaptionLabel().toUpperCase(false);
   
  // create slider B1
  sliderB1 = cp5.addSlider( "b1" ) // a0 is the control label
    .setPosition(20, 80)             // XX means you figure it out
      .setSize( sliderWid, sliderHt )   // 480 pixels wide by 20 pixels tall
        .setRange( 0, 1 )                 // slider minimum value is 0, max is 1.0
          .setValue( 0.5 )                  // initial setting at 0.5
              .setColorCaptionLabel(0)          // caption color is black
              .setColorValueLabel(0)            // label color is black
                .setDecimalPrecision(2)           // display 2 decimal places
                  .setColorBackground( bkgColor )   // dark gray
                    .setColorForeground( foreColor )  // light yellow
                      .setColorActive( activeColor )    // light yellos
                        ;
  // change control label font and size
  cp5.getController("b1").getCaptionLabel().toUpperCase(false);
  
  // create a toggle
  lohiToggle =cp5.addToggle("Lo - Hi")
    .setPosition(560, 16)
      .setSize(50, 20)
        .setValue(true)
          .setMode(ControlP5.SWITCH) // left/right switch mode
            .setColorBackground(color(128))
              .setColorForeground(color(255, 255, 162))
                .setColorActive(color(255, 255, 162))
                  ;   
  cp5.getController("Lo - Hi").getCaptionLabel().toUpperCase(false).setColor(0);

  // create a toggle
  bypassToggle =cp5.addToggle("Bypass")
    .setPosition(560, 72)
      .setSize(50, 20)
        .setValue(false)
          .setColorBackground(color(128))
            .setColorForeground(color(128))
              .setColorActive(color(255, 255, 162))
                ;    
  cp5.getController("Bypass").getCaptionLabel().toUpperCase(false).setColor(0);
} // end addGUIControls

void setup() 
{
  // set size of window
  // MUST BE first line in setup
  size( 640, 120 );           // window will be 640 pixels wide by 18 pixels tall
  noStroke();                 // no aliasing
  cp5 = new ControlP5(this);  // create the cp5 object
  addGUIControls();           // add the controls
  // OSC stuff
  // if ChucK were to send back to Processing it would send to port 12345
  oscP5 = new OscP5(this, 12345); 
  // Processing will send to ChucK on port 12346
  // 127.0.0.1 is the network address of the local machine
  ChuckAddress = new NetAddress("127.0.0.1", 12346);
}

void draw() 
{
  // width and height are Processing variables passed to
  // the the size() function in in setup()
  rect(0, 0, width, height);    
  background( color(192) );  // a gray window background
}

void sendOSCgain( float gane)
{
  // the OscMessage class has handy formatting methods
  // genereate the message title ChucK will use to identify
  // the control that sent the message
  OscMessage oscGain = new OscMessage("/lab17/gain");
  // add one float value to the message
  // the parameter gane is the current value of the slider
  oscGain.add( gane );
  //send the message immediately
  oscP5.send(oscGain, ChuckAddress);
}

void sendOSCa0( float a0 )
{
  //the OscMessage class has handy formatting methods
  OscMessage oscA0 = new OscMessage("/lab17/a0"); //greate the address
  oscA0.add( a0 );//append these items
  oscP5.send(oscA0, ChuckAddress);//send the message
}

void sendOSCb1( float b1 )
{
  //the OscMessage class has handy formatting methods
  OscMessage oscB1 = new OscMessage("/lab17/b1"); //greate the address
  oscB1.add( b1 );//append these items
  oscP5.send(oscB1, ChuckAddress);//send the message
}

void sendOSCloHi( float lo )
{
  //the OscMessage class has handy formatting methods
  OscMessage oscLoHi = new OscMessage("/lab17/lowhi"); //greate the address
  if ( lo == 1.0 )
    oscLoHi.add( 1.0 ); // plus for low pass 
  else 
    oscLoHi.add( -1.0 ); // minus for high pass
  oscP5.send(oscLoHi, ChuckAddress);//send the message
}

void sendOSCbypass( float byp )
{
  //the OscMessage class has handy formatting methods
  OscMessage oscBypass = new OscMessage("/lab17/bypass"); //greate the address
  if ( byp == 1.0 )
    oscBypass.add( 1.0 );//append these items
  else 
    oscBypass.add( 0.0 );//append these items

  oscP5.send(oscBypass, ChuckAddress);//send the message
}

void controlEvent(ControlEvent theEvent)
{
  if ( theEvent.isFrom( sliderGain ) )
  {
    float gane = sliderGain.getValue();
    sendOSCgain( gane );      
    println( "OSC sent gain", gane );
  }
  else if ( theEvent.isFrom( sliderA0 ) )
  {
    float a0 = sliderA0.getValue();
    sendOSCa0( a0 );      
    println( "a0", a0 );
  }
  else if ( theEvent.isFrom( sliderB1 ) )
  {
    float b1 = sliderB1.getValue();
    sendOSCb1( b1 );      
    println( "b1", b1 );
  }
  else if ( theEvent.isFrom( lohiToggle ) )
  {
    float lo = lohiToggle.getValue();
    sendOSCloHi( lo );  
    println( "lohi ", lo );
  }
  else if ( theEvent.isFrom( bypassToggle ) )
  {
    float byp = bypassToggle.getValue();
    sendOSCbypass( byp );  
    println( "bypass ", byp );
  }
}
